//#ifndef TARGET_SOLUTION
#include "Texture.hpp"

//#include "Util\Util.hpp"
#include <FreeImage.h>
#pragma comment(lib, "FreeImage.lib")
#include <iostream>

using namespace cgue;
//using namespace cgue::util;

Texture::Texture()
{
		bool hasMipMap = false;
}

Texture::Texture(const char *path)
{
	bool hasMipMap = false;
	unsigned char* data = LoadTexture(path);
	/*
	glGenTextures(1, &handle);

	
	
	//glActiveTexture(GL_TEXTURE0);
	
	
	glBindTexture(GL_TEXTURE_2D, handle);


	unsigned int width, height;
	unsigned char* data = LoadTexture(path, width, height);

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, width, height, 0, GL_RGB, GL_UNSIGNED_BYTE, data);
	glGenerateMipmap(GL_TEXTURE_2D);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	*/
}

Texture::~Texture()
{
	glDeleteTextures(1, &tex_handle);
}

void Texture::bind(int tex_unit)
{
	glActiveTexture(GL_TEXTURE0 + tex_unit);
	glBindTexture(GL_TEXTURE_2D, tex_handle);
}

unsigned char* Texture::LoadTexture(const char *path)
{
	/*
	FIBITMAP* bitmap = FreeImage_Load(
        FreeImage_GetFileType(path, 0),
        path);
	

	width = FreeImage_GetWidth(bitmap);
	height = FreeImage_GetHeight(bitmap);

	
	FIBITMAP *pImage = FreeImage_ConvertTo24Bits(bitmap);
	//FIBITMAP *pImage = FreeImage_ConvertTo32Bits(bitmap);
	return FreeImage_GetBits(pImage);

	/*
	FREE_IMAGE_FORMAT format = FreeImage_GetFileType(path,0);//Automatocally detects the format(from over 20 formats!)
	FIBITMAP* image = FreeImage_Load(format, path);
 
	FIBITMAP* temp = image;
	image = FreeImage_ConvertTo32Bits(image);
	FreeImage_Unload(temp);
 
	int w = FreeImage_GetWidth(image);
	int h = FreeImage_GetHeight(image);
	std::cout<<"The size of the image is: "<<path<<" es "<<w<<"*"<<h<<std::endl; //Some debugging code
 
	GLubyte* texture = new GLubyte[4*w*h];
	char* pixels = (char*)FreeImage_GetBits(image);
	//FreeImage loads in BGR format, so you need to swap some bytes(Or use GL_BGR).
 
	for(int j= 0; j<w*h; j++){
		texture[j*4+0]= pixels[j*4+2];
		texture[j*4+1]= pixels[j*4+1];
		texture[j*4+2]= pixels[j*4+0];
		texture[j*4+3]= pixels[j*4+3];
		//cout<<j<<": "<<textura[j*4+0]<<"**"<<textura[j*4+1]<<"**"<<textura[j*4+2]<<"**"<<textura[j*4+3]<<endl;
	}
	width = w;
	height = h;
	return texture;*/

	//loadImage
	
	FIBITMAP *dib1 = NULL;

	FREE_IMAGE_FORMAT fif = FreeImage_GetFIFFromFilename(path);

	dib1 = FreeImage_Load(fif, path, JPEG_DEFAULT);
	if (!dib1)
	{
		std::cerr << "image loading problem" << std::endl;
		exit (0);
	}
	//return dib1;

	//not needed -> handle saves it
	//GLuint tex_id = 0;
	int x, y;

	RGBQUAD rgbquad;


	FREE_IMAGE_TYPE type;
	BITMAPINFOHEADER *header;
  
	type = FreeImage_GetImageType(dib1);

 
	height = FreeImage_GetHeight(dib1);
	width = FreeImage_GetWidth(dib1);
  
	header = FreeImage_GetInfoHeader(dib1);
	int scanLineWidh = ((3*width)%4 == 0) ? 3*width : ((3*width)/4)*4+4;
	unsigned char * texels= (GLubyte*)calloc(height*scanLineWidh, sizeof(GLubyte));
	for (x=0 ; x<width ; x++)
		for (y=0 ; y<height; y++) {  
			FreeImage_GetPixelColor(dib1,x,y,&rgbquad);

			texels[(y*scanLineWidh+3*x)]=((GLubyte*)&rgbquad)[2];
			texels[(y*scanLineWidh+3*x)+1]=((GLubyte*)&rgbquad)[1];
			texels[(y*scanLineWidh+3*x)+2]=((GLubyte*)&rgbquad)[0];
		}
  
	//not needed
	//glActiveTexture(GL_TEXTURE0 + textureIndex);

	glGenTextures(1, &tex_handle);
	glBindTexture(GL_TEXTURE_2D, tex_handle);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);



	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB,
			width, height, 0, GL_RGB,
			GL_UNSIGNED_BYTE, texels);
	free(texels);
	
//return tex_id;

}



unsigned char* Texture::LoadTextureMipMap(const char *path,bool usemipmap)
{


	//loadImage
	
	FIBITMAP *dib1 = NULL;

	FREE_IMAGE_FORMAT fif = FreeImage_GetFIFFromFilename(path);

	dib1 = FreeImage_Load(fif, path, JPEG_DEFAULT);
	if (!dib1)
	{
		std::cerr << "image loading problem" << std::endl;
		exit (0);
	}
	//return dib1;

	//not needed -> handle saves it
	//GLuint tex_id = 0;
	int x, y;

	RGBQUAD rgbquad;


	FREE_IMAGE_TYPE type;
	BITMAPINFOHEADER *header;
  
	type = FreeImage_GetImageType(dib1);

 
	height = FreeImage_GetHeight(dib1);
	width = FreeImage_GetWidth(dib1);
  
	header = FreeImage_GetInfoHeader(dib1);
	int scanLineWidh = ((3*width)%4 == 0) ? 3*width : ((3*width)/4)*4+4;
	unsigned char * texels= (GLubyte*)calloc(height*scanLineWidh, sizeof(GLubyte));
	for (x=0 ; x<width ; x++)
		for (y=0 ; y<height; y++) {  
			FreeImage_GetPixelColor(dib1,x,y,&rgbquad);

			texels[(y*scanLineWidh+3*x)]=((GLubyte*)&rgbquad)[2];
			texels[(y*scanLineWidh+3*x)+1]=((GLubyte*)&rgbquad)[1];
			texels[(y*scanLineWidh+3*x)+2]=((GLubyte*)&rgbquad)[0];
		}
  
	//not needed
	//glActiveTexture(GL_TEXTURE0 + textureIndex);

	glGenTextures(1, &tex_handle);
	glBindTexture(GL_TEXTURE_2D, tex_handle);


	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB,
			width, height, 0, GL_RGB,
			GL_UNSIGNED_BYTE, texels);


	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	
	//Set FilterOptions
	if(usemipmap){
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	}
	else{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	}

	//Generate MIPMAP
	if(usemipmap)
		glGenerateMipmap(GL_TEXTURE_2D);

	//save true for available mipmaps
	hasMipMap = usemipmap;	//texture has now MipMap
	free(texels);
	
//return tex_id;

}