#version 330
//new
layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;
layout(location = 3) in ivec4 bone_ids;
layout(location = 4) in vec4 bone_weights;

out vec3 worldNormal;
out vec2 fUVs;
out vec3 fragPosition;
out vec4 SM_tex_coord;

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 depthBiasVP;


uniform mat4 bone_matrices[64];


void main(){

	vec4 eye_position = viewMatrix * modelMatrix * vec4(position, 1.0);

    fragPosition = eye_position.xyz;
    worldNormal   = (viewMatrix * modelMatrix  * vec4(normal, 0.0)).xyz;
    fUVs = uv;
	
	
	mat4 bonecalculation = mat4(1.0);
	bonecalculation = bone_matrices[bone_ids.x] * bone_weights.x +
							bone_matrices[bone_ids.y] * bone_weights.y +
							bone_matrices[bone_ids.z] * bone_weights.z +
							bone_matrices[bone_ids.w] * bone_weights.w;
	//bonecalculation = bone_matrices[bone_ids.x] * bone_weights.x;
	//bonecalculation = bone_matrices[bone_ids.x] * bone_weights.x + mat4(1.0) + mat4(1.0) + mat4(1.0);
	//mat4 bonecalculation = bone_matrices[bone_ids[0]] * bone_weights[0] +
	//						bone_matrices[bone_ids[1]] * bone_weights[1];

	gl_Position = projectionMatrix * modelMatrix * bonecalculation * vec4(position,1);
	SM_tex_coord = depthBiasVP * modelMatrix *bonecalculation *vec4(position,1);

}