#version 330

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 uv;
layout (location = 3) in ivec4 bone_ids;
layout (location = 4) in vec4 bone_weights;


uniform mat4 viewProjectionMatrix;
uniform mat4 modelMatrix;

uniform mat4 bone_matrices[64];

void main()
{
	mat4 bonecalculation = mat4(1.0);
	bonecalculation = bone_matrices[bone_ids.x] * bone_weights.x +
							bone_matrices[bone_ids.y] * bone_weights.y +
							bone_matrices[bone_ids.z] * bone_weights.z +
							bone_matrices[bone_ids.w] * bone_weights.w;
    gl_Position = viewProjectionMatrix * modelMatrix * bonecalculation * vec4(position, 1.0);

}