

#version 330

uniform sampler2D colorTexture;
//uniform sampler2D shadowmap;
uniform sampler2DShadow  shadowmap;

in vec3 worldNormal;
in vec2 fUVs;
in vec3 fragPosition;
in vec4 SM_tex_coord;

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
float frag_shininess= 1000; // was 0.6
float frag_specular = 0.5;

//define light direction -> also change in main()
const vec3 light_direction = vec3(0, -1, -1);

const vec4 light_diffuse = vec4(0.8, 0.8, 0.8, 0.0);
const vec4 light_ambient = vec4(0.2, 0.2, 0.2, 1.0);
const vec4 light_specular = vec4(1.0, 1.0, 1.0, 1.0);
float bias;
out vec4 fragColor;


vec2 poissonDisk[4] = vec2[](
  vec2( -0.94201624, -0.39906216 ),
  vec2( 0.94558609, -0.76890725 ),
  vec2( -0.094184101, -0.92938870 ),
  vec2( 0.34495938, 0.29387760 )
);



void main(){

/*

	float cosTheta = dot (worldNormal,light_direction);
	cosTheta = clamp(cosTheta,0.0,1.0);
	float bias = 0.005*tan(acos(cosTheta)); 
	bias = clamp(bias, 0,0.01); 
*/
	bias = 0.005;
	//start shadow map
	//add shadowmap calculations
	//perform perspective division
	vec3 text_coords = SM_tex_coord.xyz / SM_tex_coord.w;

	//read depth value from shadow map
	//float depth = texture(shadowmap, text_coords.xy).r;
	 
	//float inShadow = (depth > text_coords.z-bias) ? 1.0 : 0.0;
	//end shadow calculation
		


	float inShadow=1.0; 

	for (int i=0;i<4;i++){
	//if(texture2D(shadowmap, text_coords.xy +  poissonDisk[i]/700.0).r < text_coords.z-bias){
	if(texture(shadowmap, vec3(text_coords.xy +  poissonDisk[i]/700.0,text_coords.z-bias)) < text_coords.z){
		//if(textureProj(shadowmap, vec4(text_coords.xy +  poissonDisk[i]/700.0,text_coords.z-bias,1.0)) < text_coords.z){
	
		inShadow -= 0.2;
	}
	else{
		//	inShadow = 1.0;
	}
	}	





	vec3 mv_light_direction = normalize(viewMatrix * modelMatrix * vec4(light_direction, 0.0)).xyz;
         vec3 normal = normalize(worldNormal);
         vec3 eye = normalize(fragPosition);
         vec3 reflection = reflect(mv_light_direction, normal);

    vec4 frag_diffuse = texture2D(colorTexture, fUVs);
    vec4 diffuse_factor
        = max(-dot(normal, mv_light_direction), 0.0) * light_diffuse;
    vec4 ambient_diffuse_factor
        = diffuse_factor + light_ambient;
    vec4 specular_factor
        = max(pow(-dot(reflection, eye), frag_shininess), 0.0)
            * light_specular;
    

  fragColor = (light_ambient  + diffuse_factor) * frag_diffuse * inShadow + (light_ambient  + specular_factor) * frag_specular  * inShadow;
  fragColor.w = 1;


//EXPERIMENTE



	//fragColor = texture(colorTexture, fUVs) * inShadow;
	/*
	vec4 surfaceColor =  texture(colorTexture, fUVs);
	vec3 surfaceToLight = -light_direction;

	//intensitie added
	vec3 finalToonColor = vec3(0.0,0.0,0.0);
	
	float intensity = max(0.0, dot(normal, surfaceToLight));

	float toonFactor = 1.0;

	if(intensity > 0.95){
		toonFactor = 0.90;
	} else if(intensity > 0.50) {
		toonFactor = 0.75;
	} else if(intensity > 0.25) {
		toonFactor = 0.40;
	} else {
		toonFactor = 0.25;
	}


	vec3 textureColor = texture(colorTexture, fUVs).rgb;

	finalToonColor = finalToonColor + (toonFactor * vec3(textureColor));

	fragColor = vec4(finalToonColor, 1.0) * surfaceColor;
	*/
}


/*
void main(){

	vec3 ambientCoef = vec3(ambientLight,ambientLight,ambientLight);

    mat3 normalMatrix = transpose(inverse(mat3(modelMatrix)));
    vec3 normal = normalize(normalMatrix * worldNormal);
    

    vec3 fragPos = vec3(modelMatrix * vec4(fragPosition, 1));
    
 
    vec3 surfaceToLight = normalize(lightPos - fragPos);


	vec4 surfaceColor = texture(colorTexture, fUVs); 

	float diffuseCoef = max(0.0, dot(normal, surfaceToLight));

    vec3 diffuse = diffuseCoef * surfaceColor.rgb * lightColor;
	vec3 ambient = ambientCoef * surfaceColor.rgb *  lightColor;

	fragColor = vec4(diffuse + ambient, 1.0);
	
}
*/