#version 330

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;
layout(location = 3) in int bone_id;

out vec3 worldNormal;
out vec2 fUVs;
out vec3 fragPosition;
out vec4 SM_tex_coord;

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 depthBiasVP;

void main(){


	vec4 eye_position = viewMatrix * modelMatrix * vec4(position, 1.0);
	gl_Position = projectionMatrix * modelMatrix * vec4(position,1);

    fragPosition = eye_position.xyz;
    worldNormal   = (viewMatrix * modelMatrix  * vec4(normal, 0.0)).xyz;
    fUVs = uv;
	
	SM_tex_coord = depthBiasVP * modelMatrix * vec4(position,1);

}
